
#define BLYNK_PRINT Serial
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
#define finger_pin 15
#define wrist_pin 14
#define arm_pin 11
#define base_pin 10
// called this way, it uses the default address 0x40
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();

#define MIN_PULSE_WIDTH       650
#define MAX_PULSE_WIDTH       2350
#define DEFAULT_PULSE_WIDTH   1500
#define FREQUENCY             50
int arm_position=90;
int wrist_position=90;
int base_position=90;

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>

// You should get Auth Token in the Blynk App.
// Go to the Project Settings (nut icon).
char auth[] = "***"; //replace *** with your blynk token

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "***"; //replace *** with your wifi ssid
char pass[] = "***"; //replace *** with your wifi password
 
// Hardware Serial on Mega, Leonardo, Micro...
//#define EspSerial Serial1

// or Software Serial on Uno, Nano...
 #include <SoftwareSerial.h>
 SoftwareSerial EspSerial(4, 5); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 9600

ESP8266 wifi(&EspSerial);
int period = 1000;
unsigned long time_now = 0;

void setup()
{
  pwm.begin();
  pwm.setPWMFreq(FREQUENCY);  // Analog servos run at ~60 Hz updates

  // Debug console
  Serial.begin(9600);
  delay(10);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
 Blynk.begin(auth, wifi, ssid, pass);// using this statement when you use Blynk Cloud Server
 /*
 Blynk.begin(auth, wifi, ssid, pass,"192.168.0.37",8080); // use this when you use local Blynk server, change 192...37 to your server IP
 */
}

void loop()
{
  Blynk.run();
}
void rotate(int servo_pin,int angle)
{
  int pulse_wide, analog_value;
  pulse_wide   = map(angle, 0, 180, MIN_PULSE_WIDTH, MAX_PULSE_WIDTH);
  analog_value = int(float(pulse_wide) / 1000000 * FREQUENCY * 4096);
  pwm.setPWM(servo_pin, 0, analog_value);
}

BLYNK_WRITE(V1) {
int val=param.asInt();
 Serial.println(val);
rotate(finger_pin,val);
}
BLYNK_WRITE(V2) {
int val=param.asInt();
 Serial.println(val);
rotate(wrist_pin,val);
}
BLYNK_WRITE(V3) {
int val=param.asInt();
 Serial.println(val);
rotate(arm_pin,val);
}
BLYNK_WRITE(V4) {
int val=param.asInt();
 Serial.println(val);
rotate(base_pin,val);
}
